summaryrefslogtreecommitdiffstats
path: root/source
diff options
context:
space:
mode:
author Patrick J Volkerding <volkerdi@slackware.com>2021-08-07 19:04:04 +0000
committer Eric Hameleers <alien@slackware.com>2021-08-08 00:01:02 +0200
commit667b86aaab3e72c3c6a80e2b7dcbe2da39c89d71 (patch)
tree12041cb9dbd5f1f91ee2c6d37a9987ba7f28bf17 /source
parent295fdc80f2f76c209bec6289e8a8115cbc3867d8 (diff)
downloadcurrent-667b86aaab3e72c3c6a80e2b7dcbe2da39c89d71.tar.gz
current-667b86aaab3e72c3c6a80e2b7dcbe2da39c89d71.tar.xz
Sat Aug 7 19:04:04 UTC 202120210807190404
a/aaa_glibc-solibs-2.33-x86_64-3.txz: Rebuilt. a/usbutils-014-x86_64-1.txz: Upgraded. ap/mariadb-10.6.4-x86_64-1.txz: Upgraded. ap/nvme-cli-1.15-x86_64-1.txz: Upgraded. l/glibc-2.33-x86_64-3.txz: Rebuilt. Since glibc-2.34 makes a potentially risky change of moving all functions into the main library, and another inconvenient (for us) change of renaming the library files, we'll stick with glibc-2.33 for Slackware 15.0 and test the newer glibc in the next release cycle. But we'll backport the security fixes from glibc-2.34 with this update: The nameserver caching daemon (nscd), when processing a request for netgroup lookup, may crash due to a double-free, potentially resulting in degraded service or Denial of Service on the local system. Reported by Chris Schanzle. The mq_notify function has a potential use-after-free issue when using a notification type of SIGEV_THREAD and a thread attribute with a non-default affinity mask. The wordexp function may overflow the positional parameter number when processing the expansion resulting in a crash. Reported by Philippe Antoine. For more information, see: https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2021-27645 https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2021-33574 https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2021-35942 (* Security fix *) l/glibc-i18n-2.33-x86_64-3.txz: Rebuilt. l/glibc-profile-2.33-x86_64-3.txz: Rebuilt. l/liburing-2.0-x86_64-1.txz: Added. This is needed by mariadb, and provides increased performance on high speed devices such as NVMe. n/dovecot-2.3.16-x86_64-1.txz: Upgraded. xap/blueman-2.2.2-x86_64-1.txz: Upgraded.
Diffstat (limited to 'source')
-rwxr-xr-xsource/a/usbutils/usbutils.SlackBuild2
-rw-r--r--source/kde/kde/patch/calligra.patch1
-rw-r--r--source/kde/kde/patch/calligra/calligra-gcc11.patch48
-rw-r--r--source/kde/kde/patch/kwave.patch1
-rw-r--r--source/kde/kde/patch/kwave/kwave.gcc11.limits.patch10
-rwxr-xr-xsource/l/glibc/glibc.SlackBuild2
-rw-r--r--source/l/glibc/patches/CVE-2021-27645.patch20
-rw-r--r--source/l/glibc/patches/CVE-2021-33574_1.patch71
-rw-r--r--source/l/glibc/patches/CVE-2021-33574_2.patch53
-rw-r--r--source/l/glibc/patches/CVE-2021-35942.patch41
-rwxr-xr-xsource/l/liburing/liburing.SlackBuild135
-rw-r--r--source/l/liburing/liburing.url1
-rw-r--r--source/l/liburing/slack-desc19
13 files changed, 402 insertions, 2 deletions
diff --git a/source/a/usbutils/usbutils.SlackBuild b/source/a/usbutils/usbutils.SlackBuild
index e7794c87d..a8e1dfdf0 100755
--- a/source/a/usbutils/usbutils.SlackBuild
+++ b/source/a/usbutils/usbutils.SlackBuild
@@ -24,7 +24,7 @@ cd $(dirname $0) ; CWD=$(pwd)
PKGNAM=usbutils
VERSION=${VERSION:-$(echo usbutils-*.tar.xz | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
-BUILD=${BUILD:-3}
+BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
diff --git a/source/kde/kde/patch/calligra.patch b/source/kde/kde/patch/calligra.patch
index 8e93a639c..380aaa942 100644
--- a/source/kde/kde/patch/calligra.patch
+++ b/source/kde/kde/patch/calligra.patch
@@ -1,3 +1,4 @@
# Fix blank page in calligragemini
cat $CWD/patch/calligra/calligragemini_fix_blank_page_without_libgit2.patch | patch -p1 --verbose || { touch ${SLACK_KDE_BUILD_DIR}/${PKGNAME}.failed ; continue ; }
cat $CWD/patch/calligra/0053-Partial-update-of-Commit-62f51070-to-make-it-compile.patch | patch -p1 --verbose || { touch ${SLACK_KDE_BUILD_DIR}/${PKGNAME}.failed ; continue ; }
+cat $CWD/patch/calligra/calligra-gcc11.patch | patch -p1 --verbose || { touch ${SLACK_KDE_BUILD_DIR}/${PKGNAME}.failed ; continue ; }
diff --git a/source/kde/kde/patch/calligra/calligra-gcc11.patch b/source/kde/kde/patch/calligra/calligra-gcc11.patch
new file mode 100644
index 000000000..c47895822
--- /dev/null
+++ b/source/kde/kde/patch/calligra/calligra-gcc11.patch
@@ -0,0 +1,48 @@
+diff --git a/filters/sheets/excel/sidewinder/chartsubstreamhandler.cpp b/filters/sheets/excel/sidewinder/chartsubstreamhandler.cpp
+index feac1c6..5739328 100644
+--- a/filters/sheets/excel/sidewinder/chartsubstreamhandler.cpp
++++ b/filters/sheets/excel/sidewinder/chartsubstreamhandler.cpp
+@@ -19,6 +19,7 @@
+ Boston, MA 02110-1301, USA
+ */
+
++#include <limits>
+ #include "chartsubstreamhandler.h"
+ #include "globalssubstreamhandler.h"
+ #include "worksheetsubstreamhandler.h"
+diff --git a/filters/sheets/excel/sidewinder/objects.cpp b/filters/sheets/excel/sidewinder/objects.cpp
+index 7531dd7..6cbca37 100644
+--- a/filters/sheets/excel/sidewinder/objects.cpp
++++ b/filters/sheets/excel/sidewinder/objects.cpp
+@@ -17,6 +17,7 @@
+ Boston, MA 02110-1301, USA
+ */
+
++#include <limits>
+ #include "objects.h"
+
+ #include "generated/simpleParser.h"
+diff --git a/filters/sheets/excel/sidewinder/utils.h b/filters/sheets/excel/sidewinder/utils.h
+index 6e012b2..61d7624 100644
+--- a/filters/sheets/excel/sidewinder/utils.h
++++ b/filters/sheets/excel/sidewinder/utils.h
+@@ -23,6 +23,7 @@
+
+ #include "value.h"
+ #include <map>
++#include <limits>
+
+ #include <QString>
+ #include <QUuid>
+diff --git a/filters/sheets/excel/sidewinder/value.cpp b/filters/sheets/excel/sidewinder/value.cpp
+index bfa3351..3007058 100644
+--- a/filters/sheets/excel/sidewinder/value.cpp
++++ b/filters/sheets/excel/sidewinder/value.cpp
+@@ -17,6 +17,7 @@
+ * Boston, MA 02110-1301, USA
+ */
+
++#include <limits>
+ #include "value.h"
+ #include "utils.h"
+
diff --git a/source/kde/kde/patch/kwave.patch b/source/kde/kde/patch/kwave.patch
new file mode 100644
index 000000000..e2c07b02d
--- /dev/null
+++ b/source/kde/kde/patch/kwave.patch
@@ -0,0 +1 @@
+cat $CWD/patch/kwave/kwave.gcc11.limits.patch | patch -p1 --verbose || { touch ${SLACK_KDE_BUILD_DIR}/${PKGNAME}.failed ; continue ; }
diff --git a/source/kde/kde/patch/kwave/kwave.gcc11.limits.patch b/source/kde/kde/patch/kwave/kwave.gcc11.limits.patch
new file mode 100644
index 000000000..09df72a97
--- /dev/null
+++ b/source/kde/kde/patch/kwave/kwave.gcc11.limits.patch
@@ -0,0 +1,10 @@
+--- ./plugins/codec_wav/WavDecoder.cpp.orig 2021-07-05 14:10:02.000000000 -0500
++++ ./plugins/codec_wav/WavDecoder.cpp 2021-08-05 11:47:18.353814614 -0500
+@@ -18,6 +18,7 @@
+ #include "config.h"
+ #include <stdlib.h>
+ #include <new>
++#include <limits>
+
+ #include <audiofile.h>
+
diff --git a/source/l/glibc/glibc.SlackBuild b/source/l/glibc/glibc.SlackBuild
index 80e2f7e73..2efeaa18b 100755
--- a/source/l/glibc/glibc.SlackBuild
+++ b/source/l/glibc/glibc.SlackBuild
@@ -25,7 +25,7 @@ cd $(dirname $0) ; CWD=$(pwd)
PKGNAM=glibc
VERSION=${VERSION:-$(echo glibc-*.tar.xz | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
CHECKOUT=${CHECKOUT:-""}
-BUILD=${BUILD:-2}
+BUILD=${BUILD:-3}
# I was considering disabling NSCD, but MoZes talked me out of it. :)
#DISABLE_NSCD=" --disable-nscd "
diff --git a/source/l/glibc/patches/CVE-2021-27645.patch b/source/l/glibc/patches/CVE-2021-27645.patch
new file mode 100644
index 000000000..c568dd16b
--- /dev/null
+++ b/source/l/glibc/patches/CVE-2021-27645.patch
@@ -0,0 +1,20 @@
+--- ./nscd/netgroupcache.c.orig 2021-08-07 13:20:02.459057859 -0500
++++ ./nscd/netgroupcache.c 2021-08-07 13:22:08.983060689 -0500
+@@ -248,7 +248,7 @@
+ : NULL);
+ ndomain = (ndomain ? newbuf + ndomaindiff
+ : NULL);
+- buffer = newbuf;
++ *tofreep = buffer = newbuf;
+ }
+
+ nhost = memcpy (buffer + bufused,
+@@ -319,7 +319,7 @@
+ else if (status == NSS_STATUS_TRYAGAIN && e == ERANGE)
+ {
+ buflen *= 2;
+- buffer = xrealloc (buffer, buflen);
++ *tofreep = buffer = xrealloc (buffer, buflen);
+ }
+ else if (status == NSS_STATUS_RETURN
+ || status == NSS_STATUS_NOTFOUND
diff --git a/source/l/glibc/patches/CVE-2021-33574_1.patch b/source/l/glibc/patches/CVE-2021-33574_1.patch
new file mode 100644
index 000000000..20f1889ce
--- /dev/null
+++ b/source/l/glibc/patches/CVE-2021-33574_1.patch
@@ -0,0 +1,71 @@
+From 42d359350510506b87101cf77202fefcbfc790cb Mon Sep 17 00:00:00 2001
+From: Andreas Schwab <schwab@linux-m68k.org>
+Date: Thu, 27 May 2021 12:49:47 +0200
+Subject: [PATCH] Use __pthread_attr_copy in mq_notify (bug 27896)
+
+Make a deep copy of the pthread attribute object to remove a potential
+use-after-free issue.
+---
+ NEWS | 4 ++++
+ sysdeps/unix/sysv/linux/mq_notify.c | 15 ++++++++++-----
+ 2 files changed, 14 insertions(+), 5 deletions(-)
+
+diff --git a/NEWS b/NEWS
+index 6f4d325d55..1bf3daa502 100644
+--- a/NEWS
++++ b/NEWS
+@@ -62,6 +62,10 @@ Security related changes:
+ potentially resulting in degraded service or Denial of Service on the
+ local system. Reported by Chris Schanzle.
+
++ CVE-2021-33574: The mq_notify function has a potential use-after-free
++ issue when using a notification type of SIGEV_THREAD and a thread
++ attribute with a non-default affinity mask.
++
+ The following bugs are resolved with this release:
+
+ [The release manager will add the list generated by
+diff --git a/sysdeps/unix/sysv/linux/mq_notify.c b/sysdeps/unix/sysv/linux/mq_notify.c
+index cc575a0cdd..f7ddfe5a6c 100644
+--- a/sysdeps/unix/sysv/linux/mq_notify.c
++++ b/sysdeps/unix/sysv/linux/mq_notify.c
+@@ -133,8 +133,11 @@ helper_thread (void *arg)
+ (void) __pthread_barrier_wait (&notify_barrier);
+ }
+ else if (data.raw[NOTIFY_COOKIE_LEN - 1] == NOTIFY_REMOVED)
+- /* The only state we keep is the copy of the thread attributes. */
+- free (data.attr);
++ {
++ /* The only state we keep is the copy of the thread attributes. */
++ pthread_attr_destroy (data.attr);
++ free (data.attr);
++ }
+ }
+ return NULL;
+ }
+@@ -255,8 +258,7 @@ mq_notify (mqd_t mqdes, const struct sigevent *notification)
+ if (data.attr == NULL)
+ return -1;
+
+- memcpy (data.attr, notification->sigev_notify_attributes,
+- sizeof (pthread_attr_t));
++ __pthread_attr_copy (data.attr, notification->sigev_notify_attributes);
+ }
+
+ /* Construct the new request. */
+@@ -270,7 +272,10 @@ mq_notify (mqd_t mqdes, const struct sigevent *notification)
+
+ /* If it failed, free the allocated memory. */
+ if (__glibc_unlikely (retval != 0))
+- free (data.attr);
++ {
++ pthread_attr_destroy (data.attr);
++ free (data.attr);
++ }
+
+ return retval;
+ }
+--
+2.27.0
+
+
diff --git a/source/l/glibc/patches/CVE-2021-33574_2.patch b/source/l/glibc/patches/CVE-2021-33574_2.patch
new file mode 100644
index 000000000..608dbfdc5
--- /dev/null
+++ b/source/l/glibc/patches/CVE-2021-33574_2.patch
@@ -0,0 +1,53 @@
+From 217b6dc298156bdb0d6aea9ea93e7e394a5ff091 Mon Sep 17 00:00:00 2001
+From: Florian Weimer <fweimer@redhat.com>
+Date: Tue, 1 Jun 2021 17:51:41 +0200
+Subject: [PATCH] Fix use of __pthread_attr_copy in mq_notify (bug 27896)
+
+__pthread_attr_copy can fail and does not initialize the attribute
+structure in that case.
+
+If __pthread_attr_copy is never called and there is no allocated
+attribute, pthread_attr_destroy should not be called, otherwise
+there is a null pointer dereference in rt/tst-mqueue6.
+
+Fixes commit 42d359350510506b87101cf77202fefcbfc790cb
+("Use __pthread_attr_copy in mq_notify (bug 27896)").
+
+Reviewed-by: Siddhesh Poyarekar <siddhesh@sourceware.org>
+---
+ sysdeps/unix/sysv/linux/mq_notify.c | 11 +++++++++--
+ 1 file changed, 9 insertions(+), 2 deletions(-)
+
+diff --git a/sysdeps/unix/sysv/linux/mq_notify.c b/sysdeps/unix/sysv/linux/mq_notify.c
+index f7ddfe5a6c..6f46d29d1d 100644
+--- a/sysdeps/unix/sysv/linux/mq_notify.c
++++ b/sysdeps/unix/sysv/linux/mq_notify.c
+@@ -258,7 +258,14 @@ mq_notify (mqd_t mqdes, const struct sigevent *notification)
+ if (data.attr == NULL)
+ return -1;
+
+- __pthread_attr_copy (data.attr, notification->sigev_notify_attributes);
++ int ret = __pthread_attr_copy (data.attr,
++ notification->sigev_notify_attributes);
++ if (ret != 0)
++ {
++ free (data.attr);
++ __set_errno (ret);
++ return -1;
++ }
+ }
+
+ /* Construct the new request. */
+@@ -271,7 +278,7 @@ mq_notify (mqd_t mqdes, const struct sigevent *notification)
+ int retval = INLINE_SYSCALL (mq_notify, 2, mqdes, &se);
+
+ /* If it failed, free the allocated memory. */
+- if (__glibc_unlikely (retval != 0))
++ if (retval != 0 && data.attr != NULL)
+ {
+ pthread_attr_destroy (data.attr);
+ free (data.attr);
+--
+2.27.0
+
+
diff --git a/source/l/glibc/patches/CVE-2021-35942.patch b/source/l/glibc/patches/CVE-2021-35942.patch
new file mode 100644
index 000000000..fde0fbdb3
--- /dev/null
+++ b/source/l/glibc/patches/CVE-2021-35942.patch
@@ -0,0 +1,41 @@
+From 5adda61f62b77384718b4c0d8336ade8f2b4b35c Mon Sep 17 00:00:00 2001
+From: Andreas Schwab <schwab@linux-m68k.org>
+Date: Fri, 25 Jun 2021 15:02:47 +0200
+Subject: [PATCH] wordexp: handle overflow in positional parameter number (bug
+ 28011)
+
+Use strtoul instead of atoi so that overflow can be detected.
+---
+ posix/wordexp-test.c | 1 +
+ posix/wordexp.c | 2 +-
+ 2 files changed, 2 insertions(+), 1 deletion(-)
+
+diff --git a/posix/wordexp-test.c b/posix/wordexp-test.c
+index f93a546d7e..9df02dbbb3 100644
+--- a/posix/wordexp-test.c
++++ b/posix/wordexp-test.c
+@@ -183,6 +183,7 @@ struct test_case_struct
+ { 0, NULL, "$var", 0, 0, { NULL, }, IFS },
+ { 0, NULL, "\"\\n\"", 0, 1, { "\\n", }, IFS },
+ { 0, NULL, "", 0, 0, { NULL, }, IFS },
++ { 0, NULL, "${1234567890123456789012}", 0, 0, { NULL, }, IFS },
+
+ /* Flags not already covered (testit() has special handling for these) */
+ { 0, NULL, "one two", WRDE_DOOFFS, 2, { "one", "two", }, IFS },
+diff --git a/posix/wordexp.c b/posix/wordexp.c
+index bcbe96e48d..1f3b09f721 100644
+--- a/posix/wordexp.c
++++ b/posix/wordexp.c
+@@ -1399,7 +1399,7 @@ envsubst:
+ /* Is it a numeric parameter? */
+ else if (isdigit (env[0]))
+ {
+- int n = atoi (env);
++ unsigned long n = strtoul (env, NULL, 10);
+
+ if (n >= __libc_argc)
+ /* Substitute NULL. */
+--
+2.27.0
+
+
diff --git a/source/l/liburing/liburing.SlackBuild b/source/l/liburing/liburing.SlackBuild
new file mode 100755
index 000000000..4495478bf
--- /dev/null
+++ b/source/l/liburing/liburing.SlackBuild
@@ -0,0 +1,135 @@
+#!/bin/bash
+
+# Copyright 2021 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PKGNAM=liburing
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-1}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
+NUMJOBS=${NUMJOBS:-" -j $(expr $(nproc) + 1) "}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PKGNAM
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+cd $TMP
+rm -rf $PKGNAM-$VERSION
+tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
+cd $PKGNAM-$VERSION || exit 1
+
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \+
+
+# Configure, build, and install:
+if [ ! -r configure ]; then
+ if [ -x ./autogen.sh ]; then
+ NOCONFIGURE=1 ./autogen.sh
+ else
+ autoreconf -vif
+ fi
+fi
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --libdevdir=/usr/lib${LIBDIRSUFFIX} \
+ --includedir=/usr/include \
+ --mandir=/usr/man \
+ --datadir=/usr/share || exit 1
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+# Don't ship static library:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.a
+
+# Strip binaries:
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+# Compress manual pages:
+find $PKG/usr/man -type f -exec gzip -9 {} \+
+for i in $( find $PKG/usr/man -type l ) ; do
+ ln -s $( readlink $i ).gz $i.gz
+ rm $i
+done
+
+# Add a documentation directory:
+mkdir -p $PKG/usr/doc/${PKGNAM}-$VERSION
+cp -a \
+ COPYING* LICENSE* README* \
+ examples \
+ $PKG/usr/doc/${PKGNAM}-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/$PKGNAM-$VERSION-$ARCH-$BUILD.txz
diff --git a/source/l/liburing/liburing.url b/source/l/liburing/liburing.url
new file mode 100644
index 000000000..41b812b90
--- /dev/null
+++ b/source/l/liburing/liburing.url
@@ -0,0 +1 @@
+https://git.kernel.dk/cgit/liburing/
diff --git a/source/l/liburing/slack-desc b/source/l/liburing/slack-desc
new file mode 100644
index 000000000..9e07a9fc4
--- /dev/null
+++ b/source/l/liburing/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+liburing: liburing (io_uring instance library)
+liburing:
+liburing: This is the io_uring library, liburing. liburing provides helpers to
+liburing: setup and teardown io_uring instances, and also a simplified interface
+liburing: for applications that don't need (or want) to deal with the full
+liburing: kernel side implementation.
+liburing:
+liburing: Homepage: https://git.kernel.dk/cgit/liburing/
+liburing:
+liburing:
+liburing: